import java.lang.reflect.Method;

import models.psec.PsecUser;
import play.Application;
import play.GlobalSettings;
import play.mvc.Action;
import play.mvc.Http.Request;

import com.avaje.ebean.Ebean;

import de.ppi.psec.helper.PsecAction;


/**
 * Possible implementation of GlobalSettings, which secures all access to 
 * an method.
 * @author niels
 *
 */
public class PsecGlobal extends GlobalSettings {

    private static final boolean ENABLED = true;
    private static final String LOGIN_URL = "/login";


    @Override
    public void onStart(Application arg0) {
        if(Ebean.find(PsecUser.class).findRowCount() == 0) {
//            LoadDataHelper.insert("user-roles-permission-data.yml");
        }
        super.onStart(arg0);
    }




    @SuppressWarnings("rawtypes")
    @Override
    public Action onRequest(Request request, Method actionMethod) {
        return new PsecAction(ENABLED, LOGIN_URL, actionMethod);
    }



}
