/**
 * 
 */
package de.ppi.psec.helper;

import java.util.List;
import java.util.Map;

import play.libs.Yaml;

import com.avaje.ebean.Ebean;


/**
 * Helperclass which loads data from a yaml-file.
 * @author niels
 *
 */
public class LoadDataHelper {
    
    /**
     * Loads yaml data, where the map should contains, permissions, roles and users.
     * @param dataFileName the name of the file.
     */
    public static void insert(String dataFileName) {
            
        @SuppressWarnings("unchecked")
        Map<String,List<Object>> all = (Map<String,List<Object>>)Yaml.load(dataFileName);

        // Insert users first
        Ebean.save(all.get("permissions"));

        // Insert projects
        Ebean.save(all.get("roles"));
        for(Object role: all.get("roles")) {
            // Insert the role/permission relation
            Ebean.saveManyToManyAssociations(role, "permissions");
        }

        // Insert tasks
        Ebean.save(all.get("users"));
        for(Object user: all.get("users")) {
            // Insert the project/user relation
            //Owner-Bean und attribute.
            Ebean.saveManyToManyAssociations(user, "permissions");
            Ebean.saveManyToManyAssociations(user, "roles");
        }
            
    }
}
