/**
 * 
 */
package de.ppi.psec.services;


import java.util.List;

import models.psec.PsecRole;
import models.psec.Role;

import com.avaje.ebean.Ebean;


/**
 * PsecPersistanceService based on Ebean.
 * @author niels
 *
 */
public class RolePersistanceServiceEbean implements RolePersistanceService {
    
    private final String ebeanServer;
    
    
    /**
     * Creates a new service for teh Defaultebeanserver.
     */
    public RolePersistanceServiceEbean() {
        this(null);
    }
    
    /**
     * Creates a new service.
     * @param ebeanServer the ebeanServer which should be used.
     */
    public RolePersistanceServiceEbean(String ebeanServer) {
        super();
        this.ebeanServer = ebeanServer;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Role findRoleByName(String rolename) {
        final List<PsecRole> roles =  Ebean.getServer(ebeanServer).find(PsecRole.class).
                where().eq("byName", rolename).findList();
        if (roles.size() != 1) {
            if (roles.size() == 0) {
                return null;
            } else {
                throw new IllegalStateException("There exist not exactly 1 role to the unique-name");
            }
        }  else {
            return roles.get(0);
        }
    }


}
