/**
 * 
 */
package de.ppi.psec.services;


import models.psec.PsecUser;
import models.psec.User;

import com.avaje.ebean.Ebean;
import com.avaje.ebean.EbeanServer;


/**
 * PsecPersistanceService based on Ebean.
 * @author niels
 *
 */
public class UserPersistanceServiceEbean implements UserPersistanceService {
    
    
    private final EbeanServer ebeanServer;
    
    
    /**
     * Creates a new service for teh Defaultebeanserver.
     */
    public UserPersistanceServiceEbean() {
        this(null);
    }
    
    /**
     * Creates a new service.
     * @param ebeanServer the ebeanServer which should be used.
     */
    public UserPersistanceServiceEbean(String ebeanServer) {
        super();
        this.ebeanServer = Ebean.getServer(ebeanServer);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public User findUserById(Long userId) {
        return ebeanServer.find(PsecUser.class, userId);
        
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public User findUserByLoginname(String loginName) {
        return ebeanServer.find(PsecUser.class).
                where().eq("loginname", loginName).findUnique();
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    public void saveUser(User user) {
        ebeanServer.save(user);
    }


}
