# --- Created by Ebean DDL
# To stop Ebean DDL generation, remove this comment and start using Evolutions

# --- !Ups

create table psec_permission (
  id                        bigint not null,
  name                      varchar(255) not null,
  type                      varchar(255) not null,
  target                    varchar(255) not null,
  actions                   varchar(255) not null,
  last_update               timestamp,
  auto_updates_forbidden    boolean,
  constraint uq_psec_permission_name unique (name),
  constraint pk_psec_permission primary key (id))
;

create table psec_role (
  id                        bigint not null,
  name                      varchar(255) not null,
  last_update               timestamp,
  default_role              boolean,
  auto_updates_forbidden    boolean,
  constraint uq_psec_role_name unique (name),
  constraint pk_psec_role primary key (id))
;

create table psec_user (
  id                        bigint not null,
  loginname                 varchar(255) not null,
  email_address             varchar(255),
  lastname                  varchar(255),
  firstname                 varchar(255),
  description               varchar(255),
  enabled                   boolean not null,
  login_failed_count        integer,
  expired_date              timestamp,
  password                  varchar(255),
  last_update               timestamp,
  auto_updates_forbidden    boolean,
  constraint uq_psec_user_loginname unique (loginname),
  constraint uq_psec_user_email_address unique (email_address),
  constraint pk_psec_user primary key (id))
;


create table psec_role_psec_permission (
  psec_role_id                   bigint not null,
  psec_permission_id             bigint not null,
  constraint pk_psec_role_psec_permission primary key (psec_role_id, psec_permission_id))
;

create table psec_user_psec_role (
  psec_user_id                   bigint not null,
  psec_role_id                   bigint not null,
  constraint pk_psec_user_psec_role primary key (psec_user_id, psec_role_id))
;

create table psec_user_psec_permission (
  psec_user_id                   bigint not null,
  psec_permission_id             bigint not null,
  constraint pk_psec_user_psec_permission primary key (psec_user_id, psec_permission_id))
;
create sequence psec_permission_seq;

create sequence psec_role_seq;

create sequence psec_user_seq;




alter table psec_role_psec_permission add constraint fk_psec_role_psec_permission__01 foreign key (psec_role_id) references psec_role (id) on delete restrict on update restrict;

alter table psec_role_psec_permission add constraint fk_psec_role_psec_permission__02 foreign key (psec_permission_id) references psec_permission (id) on delete restrict on update restrict;

alter table psec_user_psec_role add constraint fk_psec_user_psec_role_psec_u_01 foreign key (psec_user_id) references psec_user (id) on delete restrict on update restrict;

alter table psec_user_psec_role add constraint fk_psec_user_psec_role_psec_r_02 foreign key (psec_role_id) references psec_role (id) on delete restrict on update restrict;

alter table psec_user_psec_permission add constraint fk_psec_user_psec_permission__01 foreign key (psec_user_id) references psec_user (id) on delete restrict on update restrict;

alter table psec_user_psec_permission add constraint fk_psec_user_psec_permission__02 foreign key (psec_permission_id) references psec_permission (id) on delete restrict on update restrict;

# --- !Downs

SET REFERENTIAL_INTEGRITY FALSE;

drop table if exists psec_permission;

drop table if exists psec_role;

drop table if exists psec_role_psec_permission;

drop table if exists psec_user;

drop table if exists psec_user_psec_role;

drop table if exists psec_user_psec_permission;

SET REFERENTIAL_INTEGRITY TRUE;

drop sequence if exists psec_permission_seq;

drop sequence if exists psec_role_seq;

drop sequence if exists psec_user_seq;

